#! /usr/bin/env python
#-*- coding: UTF8 -*-

import numpy as np
from scipy.interpolate import griddata

#-------------------------------------------------------------------------------
# Read input
#-------------------------------------------------------------------------------

print 'Starting Python Interpolation'

#Read pad_age and pad_dist from inputs_of_outputs.txt
with open('input_tracking_outputs.txt') as inparams:
    for i,line in enumerate(inparams):
        if i == 12:
            pad_age = float(line.split(' ')[0])
        if i == 13:
            pad_dist = float(line.split(' ')[0])
            break

#read surface coordinates
with open('surface.dat') as surfdata:
    surf = []
    for line in surfdata:
        surf.append( [float(num) for num in line.split()] )
    surf = np.array(surf)

#read Age data
with open('ages.dat') as agedata:
    ages = []
    for line in agedata:
        ages.append( [float(num) for num in line.split()] )
    ages = np.array(ages)
    (ntracks, nages) = ages.shape 

#-------------------------------------------------------------------------------
# Do interpolation
#-------------------------------------------------------------------------------

(nsurf, dummy) = surf.shape

interpages = np.zeros((nsurf,nages-2))

for i in xrange(2,nages):
    interpages[:,i-2] = griddata(ages[:,0:2], ages[:,i], surf, method='cubic', fill_value=pad_age)

np.savetxt('interpages.dat', interpages, fmt='%12.6e')    

